// WAR, war, what is it good for? -- TSL

$missionName = "Martian_Jailbreak";

exec("multiplayerStdLib.cs");
exec("DMStdLib.cs");

///////////////////////////////////////////////////////////////////////////////////////////////////
// Lots O' Globals
///////////////////////////////////////////////////////////////////////////////////////////////////
$redKills = 0;
$Kills = 0;

$Herc1RespawnTime = 0;
$yellowHerc2RespawnTime = 0;
$yellowHerc3RespawnTime = 0;
$redHerc1RespawnTime = 0;
$redHerc2RespawnTime = 0;
$redHerc3RespawnTime = 0;

$yellowHerc1Path = "MissionGroup/yellowHerc1Path";
$yellowHerc2Path = "MissionGroup/yellowHerc2Path";
$yellowHerc3Path = "MissionGroup/yellowHerc3Path";
$redHerc1Path = "MissionGroup/redHerc1Path";
$redHerc2Path = "MissionGroup/redHerc2Path";
$redHerc3Path = "MissionGroup/redHerc3Path";

$yellowHqDestroyed = false;
$redHqDestroyed = false;


//=======

$redTotal = 0;
$yellowTotal = 0;
$redTeamersOnField = 0;
$yellowTeamersOnField = 0;
$getOutOfJailFree = 0;
$aTaleOfTwoTeams = 0;


///////////////////////////////////////////////////////////////////////////////////////////////////
// the Game Info tab uses these variables in the rules
///////////////////////////////////////////////////////////////////////////////////////////////////
$respawnDelay = 60;
$respawnDelayNoHq = 120;

///////////////////////////////////////////////////////////////////////////////////////////////////
// our base defender attributes
//
// The jump from 0.9 to 1.0 is a big one. At skill 1.0 and accuracy 1.0 the AI units will aim 
// first for the weapons, then the legs. A little too much for this mission.
//
///////////////////////////////////////////////////////////////////////////////////////////////////
Pilot YellowPilot
{
   id = 28;
   
   name = *IDMULT_WAR_YELLOW_DEFENDER;
   
   skill = 0.9;
   accuracy = 0.9;
   aggressiveness = 1.0;
   activateDist = 850.0;
   deactivateBuff = 300.0;
   targetFreq = 2.0;
   trackFreq = 0.0;
   fireFreq = 0.2;
   LOSFreq = 0.2;
   orderFreq = 2.0;
};

Pilot RedPilot
{
   id = 29;
   
   name = *IDMULT_WAR_RED_DEFENDER;
   
   skill = 0.9;
   accuracy = 0.9;
   aggressiveness = 1.0;
   activateDist = 850.0;
   deactivateBuff = 300.0;
   targetFreq = 2.0;
   trackFreq = 0.0;
   fireFreq = 0.2;
   LOSFreq = 0.2;
   orderFreq = 2.0;
};

function initGlobalVars()
{
   $scoringFreeze = false;
   
   %playerCount = playerManager::getPlayerCount();
	// clear all points for the players
   for (%p = 0; %p < %playerCount; %p++)
	{
		%player = playerManager::getPlayerNum(%p);
      %player.numKills = 0;
   }
}

function setDefaultMissionOptions()
{
	$server::TeamPlay = True;
	$server::AllowDeathmatch = False;
	$server::AllowTeamPlay = True;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = false;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = false;
   $server::disableTeamPurple = true;
}

function setDefaultMissionItems()
{
	allowVehicle(17,FALSE);  //KnightDisrupter
	allowVehicle(8,FALSE);//Disrupter
	allowComponent(875,FALSE);//FieldStabilizer
	allowWeapon(3,FALSE);//Disrupter
}

function onMissionLoad()
{
   cdAudioCycle("Purge", "Watching", "Mechsoul"); 

   // get the original ID for each AI Herc ( for use later when we clone them )
   $yellowHerc1 = getObjectId( "MissionGroup/yellowHercs/h1" );
   $yellowHerc2 = getObjectId( "MissionGroup/yellowHercs/h2" );
   $yellowHerc3 = getObjectId( "MissionGroup/yellowHercs/h3" );
   
   $redHerc1 = getObjectId( "MissionGroup/redHercs/h1" );
   $redHerc2 = getObjectId( "MissionGroup/redHercs/h2" );
   $redHerc3 = getObjectId( "MissionGroup/redHercs/h3" );

//   %rules = "<tIDMULT_WAR_GAMETYPE>"      @        
//            "<tIDMULT_WAR_MAPNAME>"       @ 
//            $missionName                  @  
//            "<tIDMULT_WAR_OBJECTIVES_1>"  @
//            timeDifference($respawnDelay, 0)       @
//            "<tIDMULT_WAR_OBJECTIVES_2>"  @
//            timeDifference($respawnDelayNoHq, 0)   @
//            "<tIDMULT_WAR_OBJECTIVES_3>"  @
//            "<tIDMULT_WAR_OBJECTIVES_4>"  @
//            $BUILDINGS_TO_DESTROY         @
//            "<tIDMULT_WAR_OBJECTIVES_5>"  @
//            "<tIDMULT_WAR_SCORING_1>"     @
//            "<tIDMULT_WAR_SCORING_2>"     @
//            "<tIDMULT_STD_ITEMS>"         @
//            "<tIDMULT_WAR_HQ>"            @
//            "<tIDMULT_WAR_GENERATORS>"    @
//            "<tIDMULT_WAR_TURRETS>"       @
//            "<tIDMULT_WAR_FLAGS>"         @
//            "<tIDMULT_WAR_GLOW>"          @
//            "<tIDMULT_STD_HEAL>"          @
//            "<tIDMULT_STD_RELOAD_1>"      @
//            $PadWaitTime                  @
//            "<tIDMULT_STD_RELOAD_2>";
   
//   setGameInfo(%rules);
}



//====================


function setEnemyNavPoint( %this )
{
   if( getTeam(%this) == *IDSTR_TEAM_YELLOW )
   {
      setNavMarker( "MissionGroup/RedBase/n1", true, %this );
   }
   else
   {
      setNavMarker( "MissionGroup/YellowBase/n1", true, %this );
   }
}


function getTeam2(%player)
{
   if( getTeam( %player ) == *IDSTR_TEAM_YELLOW )
   {
      return *IDMULT_YELLOW;
   }
   else
   {
      return *IDMULT_RED;
   }
}

function getKills(%player)
{
   if( %player.numKills != "")
      return %player.numKills;
      
   return "0";
}

function getTeamKills(%team)
{
   if( getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW )
   {
      return $yellowKills;
   }
   else
   {
      return $redKills;
   }   
}

function redGen1::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/redBase/t1", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_BR_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen2::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/redBase/t2", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_FR_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen3::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/redBase/t3", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_CEN_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen4::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/redBase/t4", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_BL_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function redGen5::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/redBase/t5", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_RED_FL_GEN_DESTROYED;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen1::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/yellowBase/t1", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_FR_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen2::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/yellowBase/t2", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_BR_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen3::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/yellowBase/t3", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_CEN_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen4::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/yellowBase/t4", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_BL_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function yellowGen5::structure::onDestroyed( %this, %who )
{
  order( "MissionGroup/yellowBase/t5", shutdown, True );
  %player = playerManager::vehicleIdToPlayerNum( %who );

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_YELLOW_BL_GEN_DESTROYED;
  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    


  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    
}

function redHQ::structure::onDestroyed( %this, %who )
{
  %player = playerManager::vehicleIdToPlayerNum( %who );

  $redHqDestroyed = true;

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_RED_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "ene_struct_dest.wav");    
  say(IDSTR_TEAM_RED, 1234, %txt, "friend_struct_des.wav");    
  say(0, 1234, "<F5>" @ *IDMULT_WAR_RED_HQ_DESTROYED @ timeDifference($respawnDelayNoHq, 0) @ "." );
}


function yellowHQ::structure::onDestroyed( %this, %who )
{
  %player = playerManager::vehicleIdToPlayerNum( %who );
  
  $yellowHqDestroyed = true;

  %txt = "<F5>" @ getHUDName(%who) @ *IDMULT_WAR_DESTROYED_YELLOW_STRUCTURE;
  say(IDSTR_TEAM_YELLOW, 1234, %txt, "friend_struct_des.wav");    

  say(IDSTR_TEAM_RED, 1234, %txt, "ene_struct_dest.wav");    
  say(0, 1234, "<F5>" @ *IDMULT_WAR_YELLOW_HQ_DESTROYED @ timeDifference($respawnDelayNoHq, 0) @ "." );
}


function onMissionStart()
{
	$healRate = 100;   
	$ammoRate = 3;
 	$padWaitTime = 45;

	windSounds();
	marsSounds();	

   initGlobalVars();
   
   order( $yellowHerc1, guard, $yellowHerc1Path );
   order( $yellowHerc2, guard, $yellowHerc2Path );
   order( $yellowHerc3, guard, $yellowHerc3Path );
   order( $redHerc1, guard, $redHerc1Path );
   order( $redHerc2, guard, $redHerc2Path );
   order( $redHerc3, guard, $redHerc3Path );
}


// Healing Pad Functionality
//------------------------------------------------------------------------------
function ZenHeal::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}
function ZenHeal::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

// Ammo Pad Functionality
//------------------------------------------------------------------------------
function ZenAmmo::trigger::onEnter(%this, %object)
{
   	Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object)
{
   	Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}
 
function trevorsCloneVehicle(%globalVarName, %old, %x, %y, %z)
{
   %clone = cloneVehicle(%old);
   setPosition(%clone, %x, %y, %z);

   schedule( "deleteObject(" @ %old @ ");", $respawnDealNoHq + 10 );

   schedule( %globalVarName @ " = " @ %clone @ ";", 0);

   addToSet( "MissionGroup", %clone );

   %path = %globalVarName @ "Path";
   schedule( "order( " @ %clone @ ", guard, " @ %path @ " );", 1 );
}


//====================  New functions


function RedLiberate::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(%player == 0) return;

	if(%player.color == "YELLOW")
	{
		say(%player, 0, "Enemy prisoners in jail: ");
		%list = 0;

		%count = playerManager::getPlayerCount();
		for(%i = 0; %i < %count; %i++)
		{
			%current = playerManager::getPlayerNum(%i);
			if((%current.locale == 0) &&
				(%current.color == "RED"))
			{
				say(%player, 0, %current.name);
				%list = 1;
			}
		}

		if(%list == 0) say(%player, 0, "None yet");
	}

	if(%player.color == "RED")
	{
		say(everybody, 0, %player.name@ " has broken the Red jail!!!");
		freeReds();
	}
}


function YellowLiberate::trigger::onEnter(%this, %object)
{
	%player = playerManager::vehicleIdToPlayerNum(%object);
	if(%player == 0) return;

	if(%player.color == "RED")
	{
		say(%player, 0, "Enemy prisoners in jail: ");
		%list = 0;

		%count = playerManager::getPlayerCount();
		for(%i = 0; %i < %count; %i++)
		{
			%current = playerManager::getPlayerNum(%i);
			if((%current.locale == 0) &&
				(%current.color == "YELLOW"))
			{
				say(%player, 0, %current.name);
				%list = 1;
			}

		if(%list == 0) say(%player, 0, "None yet");
		}
	}

	if(%player.color == "YELLOW")
	{
		say(everybody, 0, %player.name@ " has broken the Yellow jail!!!");
		freeYellows();
	}
}

function freeReds()
{
	%count = playerManager::getPlayerCount();

	%counter = 0;
	for(%i = 0; %i < %count; %i++)
	{
		%current = playerManager::getPlayerNum(%i);
		if((%current.locale == 0) &&
				(%current.color == "RED"))
		{
			%counter = 1;
			say(everybody, 0, %current.name@ " flies the coop!");
			teleportPlayer(%current.vehicleId);
		}
	}

	if(%counter == 0)
	{
		say(everybody, 0, "Oops!  No one's in the jail!");
	}
}

function freeYellows()
{
	%count = playerManager::getPlayerCount();

	%counter = 0;
	for(%i = 0; %i < %count; %i++)
	{
		%current = playerManager::getPlayerNum(%i);
		if((%current.locale == 0) &&
				(%current.color == "YELLOW"))
		{
			%counter = 1;
			say(everybody, 0, %current.name@ " flies the coop!");
			teleportPlayer(%current.vehicleId);
		}
	}

	if(%counter == 0)
	{
		say(everybody, 0, "Oops!  No one's in the jail!");
	}
}


function massacre(%targColor)
{
	%count = playerManager::getPlayerCount();
	for(%i = 0; %i < %count; %i++)	
	{
		%temp = playerManager::getPlayerNum(%i);

		if(%temp.color == %targColor)
		{
			say(everybody, 0, %temp.name @ " is executed!");
			healObject( %temp.vehicleId, -10000);
			healObject( %temp.vehicleId, -10000);
			healObject( %temp.vehicleId, -10000);
			healObject( %temp.vehicleId, -10000);
			healObject( %temp.vehicleId, -10000);
			healObject( %temp.vehicleId, -10000);
			%temp.jailFlag = 1;

			if(%temp.color == "RED")
			{
				$yellowKills++;
			}

			if(%temp.color == "YELLOW")
			{
				$redKills++;
			}
		}
	}
}


function teleportPlayer(%vehicle)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicle);
	if(%player == 0) 
		return;

	if(%player.color == "RED")
	{
		$redTeamersOnField++;
	}
	else if(%player.color == "YELLOW")
	{
		$yellowTeamersOnField++;
	}


	%spawnPoint = randomInt(1, 8);
	fadeEvent(%player, out, 1.0, 1.0, 1.0, 1.0);
	fadeEvent(%player, in, 1.0, 1.0, 1.0, 1.0);
	%temp1 = %vehicle;

	if(%player.color == "RED")
	{
	%temp2 = "MissionGroup/RedSpawn/spawn"@%spawnPoint;
	}

	if(%player.color == "YELLOW")
	{
	%temp2 = "MissionGroup/YellowSpawn/spawn"@%spawnPoint;
	}

	warp(%temp1, %temp2); 

	schedule( "setEnemyNavPoint(" @ %vehicle @ ");", 1 );
	setVehicleRadarVisible( %vehicle, True );
	%player.jailFlag = 0;
	%player.locale = 1;
}



function startTheFight()
{
	$getOutOfJailFree = 2;
	say(everybody, 0, "Free teleports are now off; Jailbreak has begun");
}


function clearTheRooms()
{
	freeReds();
	freeYellows();
}


function endGameCheck(%color)
{
	if(%color == "RED")
	{
		if($redTotal == 0)
		{
			say(everybody, 0, "Not enough red team members left to continue the game.  Restarting mission in ten seconds");
			schedule("missionEndConditionMet();", 10);
		}

		else if($redTeamersOnField == 0)
		{
			say(everybody, 0, "The entire red team has been imprisoned!");
			say(everybody, 0, "Better dead than red -- time for an execution!");
			schedule("massacre("@%color@");", 3);
		}
	}

	if(%color == "YELLOW")
	{
		if($yellowTotal == 0)
		{
			say(everybody, 0, "Not enough yellow team members left to continue the game.  Restarting mission in ten seconds");
			schedule("missionEndConditionMet();", 10);
		}

		else if($yellowTeamersOnField == 0)
		{
			say(everybody, 0, "The entire yellow team has been imprisoned!");
			say(everybody, 0, "Wipe them out... all of them.");
			schedule("massacre("@%color@");", 3);
		}
	}
}



//-------------------------------------------------------------


function player::onAdd(%player)
{
		%player.jailFlag = 0;
}

function vehicle::onAdd(%this)
{
	// see if it is a player
	%player = playerManager::vehicleIdToPlayerNum(%this);
	if(%player == 0)
		return;

	%player.name = getHUDName(%this);
	%player.vehicle = getVehicleName(%this);
	%player.vehicleId = %this;
	%player.locale = 0;  // 0 for jail, 1 for battlefield
	setVehicleRadarVisible( %player.vehicleId, False );


	%team = getTeam(%player);
	%player.color = teamToColor(%team);
//	say(%player, 0, "Team " @ %player.color);

	if(%player.color == "RED")
	{
		$redTotal++;
		if(($yellowTotal > 0) && ($redTotal > 0))
		{
			$aTaleOfTwoTeams = 1;
		}

		if($aTaleOfTwoTeams == 0)
		{
			say(%player, 0, "Sorry -- jail teleporter inactive until both teams have at least two active members.  Waiting for more people...");
		}
		else if ((%player.jailFlag == 1) || ($getOutOfJailFree == 1))
		{
			teleportPlayer(%player.vehicleId);
		}
		else say(%player, 0, "You are in the red jail.  Please wait patiently to be freed or executed.");
	}

	if(%player.color == "YELLOW")
	{
		$yellowTotal++;
		if(($redTotal > 0) && ($yellowTotal > 0))
		{
			$aTaleOfTwoTeams = 1;
		}

		if($aTaleOfTwoTeams == 0)
		{
			say(%player, 0, "Sorry -- jail teleporter inactive until both teams have at least one active member.  Waiting for more people...");
		}
		else if ((%player.jailFlag == 1) || ($getOutOfJailFree == 1))
		{
			teleportPlayer(%player.vehicleId);
		}
		else say(%player, 0, "You are in the yellow jail.  Please wait patiently to be freed or executed.");
	}


	if(($aTaleOfTwoTeams == 1) &&
		($getOutOfJailFree == 0))
	{
		say(everybody, 0, "Both teams report active members!  Activating battlefield...");
		say(everybody, 0, "Free teleports out of jail for sixty seconds");
		clearTheRooms();
		$getOutOfJailFree = 1;
		schedule("startTheFight();", 60);
	}


}



function vehicle::onDestroyed( %this, %destroyer )
{
	%tempPlayer = playerManager::vehicleIdToPlayerNum(%this);

	if(( %tempPlayer.color == "RED" )
		&& (%tempPlayer != 0 ))
	{
		$yellowKills++;
		$redTotal--;
		if(%tempPlayer.locale == 1)
		{
	 		$redTeamersOnField--;
		}

		schedule("endGameCheck("@%tempPlayer.color@");", 5);
   }
   else if(( %tempPlayer.color == "YELLOW" )
		&& (%tempPlayer != 0))
   {
		$redKills++;
		$yellowTotal--;
		if(%tempPlayer.locale == 1)
		{
	 		$yellowTeamersOnField--;
		}

		schedule("endGameCheck("@%tempPlayer.color@");", 5);
   }


   // award the player a kill ( if the enemy is a different color )
   if( getTeam( %destroyer ) != getTeam( %this ) )
   {
      %player = playerManager::vehicleIdToPlayerNum( %destroyer );
      if(%player != 0)
      {
         %player.numKills++;      
      }
   }
   
   //----------------------------------------------------------------
   // If any of our AI hercs die, give a message and re-clone/drop them
   //----------------------------------------------------------------
   if( %this == $yellowHerc1 )
   {
      $yellowHercsDestroyed++;
      
      if( $yellowHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc1\", " @ %this @ ", -320, -385, 1312);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc1\", " @ %this @ ", -320, -385, 1312);", $respawnDelayNoHq);
      }
   }
   if( %this == $yellowHerc2 )
   {
      $yellowHercsDestroyed++;

      if( $yellowHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc2\", " @ %this @ ", -120, -15, 1328);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc2\", " @ %this @ ", -120, -15, 1328);", $respawnDelayNoHq);
      }
   }
   if( %this == $yellowHerc3 )
   {
      $yellowHercsDestroyed++;
      
      if( $yellowHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc3\", " @ %this @ ", -63, -612, 1312);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$yellowHerc3\", " @ %this @ ", -63, -612, 1312);", $respawnDelayNoHq);
      }
   }

   if( %this == $redHerc1 )
   {
      $redHercsDestroyed++;
      
      if( $redHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$redHerc1\", " @ %this @ ", -2318, -38, 1478);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$redHerc1\", " @ %this @ ", -2318, -38, 1478);", $respawnDelayNoHq);
      }
   }
   if( %this == $redHerc2 )
   {
      $redHercsDestroyed++;
      
      if( $redHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$redHerc2\", " @ %this @ ", -2654, -249, 1431);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$redHerc2\", " @ %this @ ", -2654, -249, 1431);", $respawnDelayNoHq);
      }
   }
   if( %this == $redHerc3 )
   {
      $redHercsDestroyed++;
      
      if( $redHqDestroyed == false )
      {
         schedule( "trevorsCloneVehicle(\"$redHerc3\", " @ %this @ ", -2514, -253, 1438);", $respawnDelay);
      }
      else
      {
         schedule( "trevorsCloneVehicle(\"$redHerc3\", " @ %this @ ", -2514, -253, 1438);", $respawnDelayNoHq);
      }
   }

   // left over from missionStdLib.cs
   vehicle::onDestroyedLog(%this, %destroyer);
   
   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%destroyer));
   if(%message != "")
   {
      say( 0, 0, %message);
   }

   // rules enforcement
   if(
      (getTeam(%this) == getTeam(%destroyer)) &&
      (%this != %destroyer)
   )
   {
      antiTeamKill(%destroyer);
   }
}



function teamToColor(%team)
{
	if(%team == *IDSTR_TEAM_YELLOW)
	{return "YELLOW";}
	if(%team == *IDSTR_TEAM_BLUE)
	{return "BLUE";}
	if(%team == *IDSTR_TEAM_RED)
	{return "RED";}
	if(%team == *IDSTR_TEAM_PURPLE)
	{return "PURPLE";}

	return 0;
}   